ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.17 by root, Wed Mar 14 16:23:26 2007 UTC vs.
Revision 1.86 by root, Tue Oct 5 22:33:10 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
25use Storable; $Storable::canonical = 1; 54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 59
27sub usage { 60sub usage {
28 warn <<EOF; 61 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 63 [--install-arch path]
41my $VERBOSE = 1; 74my $VERBOSE = 1;
42my $CACHE = 0; 75my $CACHE = 0;
43my $FORCE; 76my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
46 96
47END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
48 98
49Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
51 123
52mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
53 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
54 126
55sub fork_sub(&) { 127sub fork_sub(&) {
68} 140}
69 141
70sub inst_maps($) { 142sub inst_maps($) {
71 my (undef, $path) = @_; 143 my (undef, $path) = @_;
72 144
73 print "installing '$path' to '$DATADIR/maps'\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 146
75 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
78 } 150 }
79 151
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
81 and die "map installation failed.\n"; 156 and die "map installation failed.\n";
82 157
83 print "maps installed successfully.\n"; 158 print "maps installed successfully.\n";
84} 159}
85 160
86{ 161{
87 our %PNG32; 162 our %ANIMINFO;
88 our %FACEINFO; 163 our %FACEINFO;
164 our %RESOURCE;
89 our @ARC; 165 our @ARC;
166 our %ARC;
90 our $TRS; 167 our $TRS;
91 our $NFILE; 168 our $NFILE;
92 our %ANIM; 169 our $PATH;
93 170
94 our (@png, @trs, @arc); # files we are interested in 171 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
95 172
173 our $c_arc = new Coro::Channel;
174 our $c_trs = new Coro::Channel;
175 our $c_res = new Coro::Channel;
176
177 our @c_png;
178
96 sub commit_png { 179 sub commit_png($$$$) {
97 my ($name, $data) = @_; 180 my ($stem, $name, $data, $T) = @_;
98 181
99 $PNG32{$name} = $data; 182 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
100 $FACEINFO{$name} ||= {}; 183 $FACEINFO{$name}{"data$T"} = $data;
101 } 184 }
102 185
103 sub process_png { 186 sub process_png {
104 while (@png) { 187 while (@c_png) {
105 my $path = pop @png; 188 my ($path, $delete) = @{pop @c_png};
106 189
107 my $png; 190 my $png;
108 aio_lstat $path; 191 aio_lstat $path;
109 my ($size, $mtime) = (stat _)[7,9]; 192 my ($size, $mtime) = (stat _)[7,9];
110 193
111 if (0 > aio_load $path, $png) { 194 if (0 > aio_load $path, $png) {
112 warn "$path: $!, skipping.\n"; 195 warn "$path: $!, skipping.\n";
113 next; 196 next;
114 } 197 }
115 198
199 my $stem = $path;
200 my $T;
201
202 if ($stem =~ s/\.32x32\.png~?$//) {
203 $T = 32;
204 } elsif ($stem =~ s/\.64x64\.png~?$//) {
205 $T = 64;
206 } else {
207 warn "$path: weird filename, skipping.\n";
208 next;
209 }
210
116 # quickly extract width and height of the (necessarily PNG) image 211 # quickly extract width and height of the (necessarily PNG) image
117 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 212 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
118 warn "$path: not a recongized png file, skipping.\n"; 213 warn "$path: not a recognized png file, skipping.\n";
119 next; 214 next;
120 } 215 }
121 216
122 my ($w, $h) = unpack "NN", $1; 217 my ($w, $h) = unpack "NN", $1;
123
124 (my $face = $path) =~ s/^.*\///;
125 my $T = 32;
126
127 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
128 warn "$path: weird filename, skipping.\n";
129 next;
130 }
131 218
132 if ($w < $T || $h < $T) { 219 if ($w < $T || $h < $T) {
133 warn "$path: too small ($w $h), skipping.\n"; 220 warn "$path: too small ($w $h), skipping.\n";
134 next; 221 next;
135 } 222 }
137 if ($w % $T || $h % $T) { 224 if ($w % $T || $h % $T) {
138 warn "$path: weird png size ($w $h), skipping.\n"; 225 warn "$path: weird png size ($w $h), skipping.\n";
139 next; 226 next;
140 } 227 }
141 228
229 (my $base = $stem) =~ s/^.*\///;
230
231 my $fi = $FACEINFO{$base};
232 unless ($fi) {
233 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
234 #next;
235 }
236
237 my $arc = $fi->{arc} || { };
238
239 unless ($path =~ /~$/) {
240 # possibly enlarge
241 if (0 > aio_stat "$stem.64x64.png") {
242 my $other = "$stem.64x64.png~";
243
244 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
245 fork_sub {
246 my $CROP;
247 my $SRC = "png:\Q$path\E";
248
249 my $is_floor = $arc->{is_floor};
250 my $is_wall = 0;
251
252 my ($wall_pfx, $wall_dir, $wall_sfx);
253
254 if (
255 !$is_floor
256 && !$arc->{alive}
257 && $arc->{move_block} eq "all"
258 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
259 ) {
260 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
261
262 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
263 $is_wall = 1;
264 }
265 }
266
267 if ($is_wall || $is_floor) {
268 # add a 4px border and add other images around it
269 $CROP = "-shave 8x8 +repage";
270
271 $w += 8;
272 $h += 8;
273
274 $SRC = "-size ${w}x${h} xc:transparent";
275 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
276
277 # 8 surrounding images
278 for (
279 # x y b r0 r1
280 [-1, -1, 0, 6],
281 [ 0, -1, 1, 10, 14],
282 [+1, -1, 0, 12],
283
284 [-1, 0, 8, 5, 7],
285 #
286 [+1, 0, 2, 5, 13],
287
288 [-1, +1, 0, 3],
289 [ 0, +1, 4, 10, 11],
290 [+1, +1, 0, 9],
291 ) {
292 my ($x, $y, $d, $r0, $r1) = @$_;
293
294 my $tile = $is_floor ? $path
295 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
296 : die;
297
298 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
299 "\Q$tile",
300 $x * ($w - 8) + 4,
301 $y * ($h - 8) + 4;
302 }
303 }
304
305 system "convert -depth 8 $SRC rgba:-"
306 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
307 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
308 and die "convert/cfhq2xa pipeline error: status $? ($!)";
309 system $OPTIPNG, "-i0", "-q", "$other~";
310 die "$other~ has zero size, aborting." unless -s "$other~";
311 rename "$other~", $other;
312 };
313 }
314
315 push @c_png, [$other, !$CACHE];
316 }
317
318 # possibly scale down
319 if (0 > aio_stat "$stem.32x32.png") {
320 my $other = "$stem.32x32.png~";
321
322 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
323 fork_sub {
324 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
325 system $OPTIPNG, "-i0", "-q", "$other~";
326
327 # reduce smoothfaces >10000 bytes
328 # obsolete, no longer required
329 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
330 my $ncolor = 256;
331 while () {
332 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
333 system $OPTIPNG, "-i0", "-q", "$other~~";
334 last if 10000 > -s "$other~~";
335 $ncolor = int $ncolor * 0.9;
336 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
337 }
338
339 printf "reduced %s from %d to %d bytes using %d colours.\n",
340 $other, -s "$other~", -s "$other~~", $ncolor
341 if $VERBOSE >= 2;
342 rename "$other~~", "$other~";
343 }
344
345 die "$other~ has zero size, aborting." unless -s "$other~";
346 rename "$other~", $other;
347 };
348 }
349
350 #warn "scaled down $path to $other\n";#d#
351 push @c_png, [$other, !$CACHE];
352 }
353 }
354
355 (my $face = $stem) =~ s/^.*\///;
356
357 # split all bigfaces, but avoid smoothfaces (*_S)
142 if (($w > $T || $h > $T) && $face !~ /_S\./) { 358 if (($w > $T || $h > $T) && $face !~ /_S\./) {
143 # split 359 # split
144 my @tile; 360 my @tile;
145 for my $x (0 .. (int $w / $T) - 1) { 361 for my $x (0 .. (int $w / $T) - 1) {
146 for my $y (0 .. (int $h / $T) - 1) { 362 for my $y (0 .. (int $h / $T) - 1) {
160 ( 376 (
161 "(", 377 "(",
162 "+clone", 378 "+clone",
163 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 379 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
164 "+repage", 380 "+repage",
381 -quality => "00",
165 -write => "png:$_->[2]~", 382 -write => "png32:$_->[2]~",
166 "+delete", 383 "+delete",
167 ")", 384 ")",
168 ) 385 )
169 } @todo), 386 } @todo),
170 "null:"; 387 "null:";
174 close $convert; 391 close $convert;
175 392
176 # pass 2, optimise, and rename 393 # pass 2, optimise, and rename
177 for (@todo) { 394 for (@todo) {
178 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 395 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
396 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
179 rename "$_->[2]~", $_->[2]; 397 rename "$_->[2]~", $_->[2];
180 } 398 }
181 }; 399 };
182 } 400 }
183 401
187 405
188 if (0 > aio_load $file, $tile) { 406 if (0 > aio_load $file, $tile) {
189 die "$path: unable to read tile +$x+$y, aborting.\n"; 407 die "$path: unable to read tile +$x+$y, aborting.\n";
190 } 408 }
191 IO::AIO::aio_unlink $file unless $CACHE; 409 IO::AIO::aio_unlink $file unless $CACHE;
192 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 410 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
193 } 411 }
194 } else { 412 } else {
195 # use as-is (either small, use smooth) 413 # use as-is (either small, use smooth)
196 commit_png $face, $png; 414 commit_png $stem, $face, $png, $T;
197 } 415 }
416
417 aio_unlink $path if $delete;
198 } 418 }
199 } 419 }
200 420
201 sub process_arc { 421 sub process_arc {
202 while (@arc) { 422 while (my $job = $c_arc->get) {
203 my ($dir, $file) = @{pop @arc}; 423 my ($dir, $file) = @$job;
204 424
205 my $arc; 425 my $arc;
206 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 426 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
207 427
208 my $arc = read_arch "$dir/$file"; 428 my $arc = read_arch "$dir/$file";
209 for my $o (values %$arc) { 429 for my $o (values %$arc) {
210 push @ARC, $o; 430 push @ARC, $o;
431 for (my $m = $o; $m; $m = $m->{more}) {
432 $ARC{$m->{_name}} = $m;
433 }
211 434
212 $o->{editor_folder} = $dir; 435 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
213 436
214 my $visibility = delete $o->{visibility}; 437 my $visibility = delete $o->{visibility};
215 my $magicmap = delete $o->{magicmap}; 438 my $magicmap = delete $o->{magicmap};
439 my $glyph = delete $o->{glyph};
216 440
217 # find upper left corner :/ 441 # find upper left corner :/
218 # omg, this is sooo broken 442 # omg, this is sooo broken
219 my ($dx, $dy); 443 my ($dx, $dy);
220 for (my $o = $o; $o; $o = $o->{more}) { 444 for (my $o = $o; $o; $o = $o->{more}) {
226 my $x = $o->{x} - $dx; 450 my $x = $o->{x} - $dx;
227 my $y = $o->{y} - $dy; 451 my $y = $o->{y} - $dy;
228 452
229 my $ext = $x|$y ? "+$x+$y" : ""; 453 my $ext = $x|$y ? "+$x+$y" : "";
230 454
231 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 455 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
232 456
233 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 457 $visibility = delete $o->{visibility} if exists $o->{visibility};
234 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 458 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
459 $glyph = delete $o->{glyph} if exists $o->{glyph};
235 460
236 my $anim = delete $o->{anim}; 461 my $anim = delete $o->{anim};
237 462
238 if ($anim) { 463 if ($anim) {
464 # possibly add $ext to the animation name to avoid
465 # the need to specify archnames for all parts
466 # of a multipart archetype.
239 $o->{animation} = "$o->{_name}"; 467 $o->{animation} = "$o->{_name}";
468 my $facings = 1;
469 my @frames;
240 470
241 for (@$anim) { 471 for (@$anim) {
242 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 472 if (/^facings\s+(\d+)/) {
473 $facings = $1*1;
474 } elsif (/^blank.x11$|^empty.x11$/) {
475 push @frames, $_;
476 } else {
477 push @frames, "$_$ext";
478 }
243 } 479 }
244 480
245 $ANIM{"$o->{_name}$ext"} = 481 $ANIMINFO{$o->{animation}} = {
246 join "", map "$_\n", 482 facings => $facings,
247 "anim $o->{_name}", 483 frames => \@frames,
248 @$anim,
249 "mina";
250 } 484 };
485 }
251 486
252 for my $face ($o->{face} || (), @{$anim || []}) { 487 for ($o->{face} || (), @{$anim || []}) {
253 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 488 next if /^facings\s/;
254 489
490 my $face = $_;
491 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
492
255 my $info = $FACEINFO{$face} ||= {}; 493 my $info = $FACEINFO{$face} ||= { };
494 $info->{arc} = $o;
495
496 next if $face =~ /^blank.x11$|^empty.x11$/;
256 497
257 $info->{visibility} = $visibility if defined $visibility; 498 $info->{visibility} = $visibility if defined $visibility;
258 $info->{magicmap} = $magicmap if defined $magicmap; 499 $info->{magicmap} = $magicmap if defined $magicmap;
500 $info->{glyph} = $glyph if defined $glyph;
259 } 501 }
260 502
261 if (my $smooth = delete $o->{smoothface}) { 503 if (my $smooth = delete $o->{smoothface}) {
262 my ($face, $smooth) = split /\s+/, $smooth; 504 my %kv = split /\s+/, $smooth;
263 # skip empty_S.x11, it seems to server no purpose whatsoever 505 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
264 # but increases bandwidth demands and worse. 506 while (my ($face, $smooth) = each %kv) {
265 unless ($smooth eq "empty_S.x11") { 507 $FACEINFO{$smooth}{arc} = $o;
508
266 $FACEINFO{$face}{smooth} = $smooth; 509 $FACEINFO{$face}{smooth} = $smooth;
510 $FACEINFO{$face}{smoothlevel} = $level;
267 } 511 }
268 } 512 }
269 } 513 }
270 } 514 }
271 } 515 }
272 } 516 }
273 517
274 sub process_trs { 518 sub process_trs {
275 while (@trs) { 519 while (my $job = $c_trs->get) {
276 my ($dir, $file) = @{pop @trs}; 520 my ($dir, $file) = @$job;
277 my $path = "$dir/$file"; 521 my $path = "$dir/$file";
278 522
279 my $trs; 523 my $trs;
280 if (0 > aio_load $path, $trs) { 524 if (0 > aio_load $path, $trs) {
281 warn "$path: $!, skipping.\n"; 525 warn "$path: $!, skipping.\n";
284 528
285 $TRS .= $trs; 529 $TRS .= $trs;
286 } 530 }
287 } 531 }
288 532
533 my %FILECACHE;
534
535 sub load_cached($;$) {
536 unless (exists $FILECACHE{$_[0]}) {
537 my $data;
538 if (0 < aio_load $_[0], $data) {
539 if ($_[1]) {
540 $data = eval { $_[1]->($data) };
541 warn "$_[0]: $@" if $@;
542 }
543 }
544
545 $FILECACHE{$_[0]} = $data;
546 }
547
548 $FILECACHE{$_[0]}
549 }
550
551 sub process_res {
552 while (my $job = $c_res->get) {
553 my ($dir, $file, $type) = @$job;
554
555 my $data;
556 aio_load "$dir/$file", $data;
557
558 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
559
560 utf8::decode $dir;
561 utf8::decode $file;
562
563 # a meta file for resources is now mandatory
564 unless (exists $meta->{$file}) {
565 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
566 next;
567 }
568
569 $meta = {
570 %{ $meta->{"" } || {} },
571 %{ $meta->{$file} || {} },
572 };
573
574 if ($meta->{license} =~ s/^#//) {
575 $meta->{license} = ({
576 "pd" => "Public Domain",
577 "gpl" => "GNU General Public License, version 3.0 or any later",
578 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
579 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
580 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
581 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
582 })->{$meta->{license}}
583 || warn "$dir/$file: license tag '$meta->{license}' not found.";
584 }
585
586 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
587 ($meta->{author} = $1) =~ s/_/ /g;
588 }
589
590 $file =~ s/\.res$//;
591 $file =~ s/\.(ogg|wav|jpg|png)$//;
592
593 substr $dir, 0, 1 + length $PATH, "";
594
595 if (my $filter = $meta->{cfutil_filter}) {
596 if ($filter eq "yaml2json") {
597 $data = JSON::XS::encode_json YAML::XS::Load $data;
598 } elsif ($filter eq "json2json") {
599 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
600 } elsif ($filter eq "perl2json") {
601 $data = eval $data; die if $@;
602 $data = JSON::XS::encode_json $data;
603 } else {
604 warn "$dir/$file: unknown filter $filter, skipping\n";
605 }
606 }
607
608 $RESOURCE{"$dir/$file"} = {
609 type => (exists $meta->{type} ? delete $meta->{type} : $type),
610 data => $data,
611 %$meta ? (meta => $meta) : (),
612 };
613 }
614 }
615
289 sub find_files; 616 sub find_files;
290 sub find_files { 617 sub find_files {
291 my ($path) = @_; 618 my ($path) = @_;
292 619
293 IO::AIO::aioreq_pri 4; 620 IO::AIO::aioreq_pri 4;
294 IO::AIO::aio_scandir $path, 4, sub { 621 IO::AIO::aio_scandir $path, 4, sub {
295 my ($dirs, $nondirs) = @_; 622 my ($dirs, $nondirs) = @_;
296 623
297 find_files "$path/$_" 624 find_files "$path/$_"
298 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 625 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
626
627 my $dir = $path;
628 substr $dir, 0, 1 + length $PATH, "";
299 629
300 for my $file (@$nondirs) { 630 for my $file (@$nondirs) {
631 if ($dir =~ /^music(?:\/|$)/) {
632 $c_res->put ([$path, $file, 3]) # FT_MUSIC
633 if $file =~ /\.(ogg)$/;
634
635 } elsif ($dir =~ /^sound(?:\/|$)/) {
636 $c_res->put ([$path, $file, 5]) # FT_SOUND
637 if $file =~ /\.(wav|ogg)$/;
638
639 } elsif ($dir =~ /^res(?:\/|$)/) {
640 if ($file =~ /\.(jpg|png)$/) {
641 $c_res->put ([$path, $file, 0]) # FT_FACE
642 } elsif ($file =~ /\.(res)$/) {
643 $c_res->put ([$path, $file, 6]) # FT_RSRC
644 } else {
645 $c_res->put ([$path, $file, undef]);
646 }
647
301 if ($file =~ /\.png$/) { 648 } elsif ($file =~ /\.png$/) {
302 push @png, "$path/$file"; 649 push @c_png, ["$path/$file", 0];
650
303 } elsif ($file =~ /\.trs$/) { 651 } elsif ($file =~ /\.trs$/) {
304 push @trs, [$path, $file]; 652 $c_trs->put ([$path, $file]);
653
305 } elsif ($file =~ /\.arc$/) { 654 } elsif ($file =~ /\.arc$/) {
306 push @arc, [$path, $file]; 655 $c_arc->put ([$path, $file]);
656
307 } else { 657 } else {
308 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 658 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
309 } 659 }
310 } 660 }
311 }; 661 };
662 }
663
664 sub generate_plurals {
665# use Lingua::EN::Inflect ();
666# Lingua::EN::Inflect::classical;
667# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
668# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
669#
670# for my $a (@ARC) {
671# my $name = $a->{name} || $a->{_name};
672#
673# next unless $a->{name_pl};
674# next if $a->{invisible};
675# next if $a->{is_floor};
676# next if $a->{no_pick};
677#
678# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
679# my $pl = $test =~ /^(?:eq|p:.)$/
680# ? $name
681# : Lingua::EN::Inflect::PL $name;
682#
683# if ($pl ne $a->{name_pl}) {
684# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
685# }
686# }
312 } 687 }
313 688
314 sub inst_arch($) { 689 sub inst_arch($) {
315 my (undef, $path) = @_; 690 my (undef, $path) = @_;
316 691
692 $PATH = $path;
693
694 print "\n",
317 print "installing '$path' to '$DATADIR'\n"; 695 "Installing '$path' to '$DATADIR'\n",
696 "\n",
697 "This can take a long time if you run this\n",
698 "for the first time or do not use --cache.\n",
699 "\n",
700 "Unless you run verbosely, all following warning\n",
701 "or error messages indicate serious problems.\n",
702 "\n";
318 703
319 if (!-d "$path/treasures") { 704 if (!-d "$path/treasures") {
320 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 705 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
321 exit 1 unless $FORCE; 706 exit 1 unless $FORCE;
322 } 707 }
323 708
709 print "scanning files...\n" if $VERBOSE;
710
324 find_files $path; 711 find_files $path;
712
713 my @a_arc = map +(async \&process_arc), 1..2;
714 my @a_res = map +(async \&process_res), 1..2;
715 my @a_trs = map +(async \&process_trs), 1..2;
716
325 IO::AIO::flush; 717 IO::AIO::flush;
326 718
327 $_->join for ( 719 $c_res->shutdown;
328 (async \&process_png), (async \&process_png), 720 $c_arc->shutdown;
329 (async \&process_trs), (async \&process_trs), 721 $c_trs->shutdown;
330 (async \&process_arc), (async \&process_arc),
331 );
332 722
723 print "start file scan, arc, res processing...\n" if $VERBOSE;
724
725 $_->join for @a_arc; # need to parse all archetypes before png processing
726
727 print "end arc, start png processing...\n" if $VERBOSE;
728
729 # eight png crunchers work fine for my 4x smp machine
730 my @a_png = map +(async \&process_png), 1..8;
731
732 $_->join for (@a_trs, @a_res, @a_png);
733
734 print "scanning done, processing results...\n" if $VERBOSE;
333 { 735 {
334 open my $fh, ">:utf8", "$DATADIR/animations~" 736 # remove path prefix from editor_folder
335 or die "$DATADIR/animations~: $!"; 737 $_->{editor_folder} =~ /^\x00/
336 print $fh join "", map $ANIM{$_}, sort keys %ANIM 738 and substr $_->{editor_folder}, 0, 2 + length $path, ""
739 for values %ARC;
740
741 print "resolving inheritance tree...\n" if $VERBOSE;
742 # resolve inherit
743 while () {
744 my $progress;
745 my $loop;
746
747 for my $o (values %ARC) {
748 for my $other (split /,/, $o->{inherit}) {
749 if (my $s = $ARC{$other}) {
750 if ($s->{inherit}) {
751 $loop = $s;
752 } else {
753 delete $o->{inherit};
754 my %s = %$s;
755 delete @s{qw(_name more name name_pl)};
756 %$o = ( %s, %$o );
757 ++$progress;
758 }
759 } else {
760 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
761 delete $ARC{$o->{_name}};
762 }
763 }
764 }
765
766 unless ($progress) {
767 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
768 if $loop;
769
770 last;
771 }
337 } 772 }
338 773
339 { 774 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
775 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
776
777 print "generating plurals...\n" if $VERBOSE;
778 generate_plurals;
779
780 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
340 open my $fh, ">:utf8", "$DATADIR/archetypes~" 781 open my $fh, ">:utf8", "$DATADIR/archetypes~"
341 or die "$DATADIR/archetypes~: $!"; 782 or die "$DATADIR/archetypes~: $!";
342 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 783 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
343 print $fh Crossfire::archlist_to_string \@ARC;
344 } 784 }
345 785
346 { 786 {
787 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
347 open my $fh, ">:utf8", "$DATADIR/treasures~" 788 open my $fh, ">:utf8", "$DATADIR/treasures~"
348 or die "$DATADIR/treasures~: $!"; 789 or die "$DATADIR/treasures~: $!";
349 print $fh $TRS; 790 print $fh $TRS;
350 } 791 }
351 792
352 { 793 {
353 while (my ($k, $v) = each %FACEINFO) { 794 print "processing facedata...\n" if $VERBOSE;
354 $v->{data32} ||= delete $PNG32{$k};
355 }
356
357 while (my ($k, $v) = each %FACEINFO) { 795 while (my ($k, $v) = each %FACEINFO) {
358 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 796 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
797 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
359 798
360 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 799 make_hash $k, $v->{data32}, $v->{hash32};
800 make_hash $k, $v->{data64}, $v->{hash64};
801
802 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
803 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
804
805 my $stem = delete $v->{stem};
806 $v->{glyph} //= substr $stem, 0, 1;
807
808 if (my $magicmap = $v->{magicmap}) {
809 $magicmap =~ y/A-Z_\-/a-z/d;
810 $v->{magicmap} = $COLOR{$magicmap};
361 } 811 }
362 812
813 delete $v->{arc};
814 }
815
816 print "processing resources...\n" if $VERBOSE;
817 my $enc = JSON::XS->new->utf8->canonical->relaxed;
818 while (my ($k, $v) = each %RESOURCE) {
819
820 if ($v->{meta} && $v->{meta}{datadir}) {
821 delete $RESOURCE{$k};
822
823 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
824
825 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
826 open my $fh, ">:raw", "$DATADIR/$k~"
827 or die "$DATADIR/$k~: $!";
828 syswrite $fh, $v->{data};
829 push @COMMIT, $k;
830
831 } else {
832 if ($v->{type} & 1) {
833 # prepend meta info
834
835 my $meta = $enc->encode ({
836 name => $k,
837 %{ $v->{meta} || {} },
838 });
839
840 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
841 }
842
843 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
844 }
845 }
846
847 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
848 scalar keys %FACEINFO,
849 scalar keys %ANIMINFO,
850 scalar keys %RESOURCE
851 if $VERBOSE;
852
363 open my $fh, ">:perlio", "$DATADIR/faces~" 853 open my $fh, ">:perlio", "$DATADIR/facedata~"
364 or die "$DATADIR/faces~: $!"; 854 or die "$DATADIR/facedata~: $!";
365 855
366 $FACEINFO{""} = { version => 1}; 856 print $fh nfreeze {
367 print $fh Storable::nfreeze \%FACEINFO; 857 version => 2,
858 faceinfo => \%FACEINFO,
859 animinfo => \%ANIMINFO,
860 resource => \%RESOURCE,
368 } 861 };
369 862
863 }
864
865 print "committing files...\n" if $VERBOSE;
866
370 for (qw(archetypes faces animations treasures)) { 867 for (qw(archetypes facedata treasures), @COMMIT) {
371 chmod 0644, "$DATADIR/$_~"; 868 chmod 0644, "$DATADIR/$_~";
372 rename "$DATADIR/$_~", "$DATADIR/$_" 869 rename "$DATADIR/$_~", "$DATADIR/$_"
373 or die "$DATADIR/$_: $!"; 870 or die "$DATADIR/$_: $!";
374 } 871 }
375 872

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines